<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">

<HTML>

<HEAD>
<TITLE>Cours/TD - 6</TITLE>
<link REL="StyleSheet" TYPE="text/css" HREF="Costyle.css">

</HEAD>
<BODY BACKGROUND="../icons/hrsc.jpg">

<CENTER><H1>Cours/TD - (6)</H1>
</CENTER>
<P>
<p>


<TABLE width=100%>
 <TR><TD align=left><A HREF="comres5.html"><IMG SRC="../icons/gb_larr.gif" border=0 align=absmiddle></A></TD>
<TD align=right><A HREF="comres7.html"><IMG SRC="../icons/gb_rarr.gif" border=0 align=absmiddle></A></TD>
</TR>
</TABLE>
<p>
<FONT COLOR=#0000FF FACE="Helvetica,Arial" point-size=14pt>

<H3><FONT COLOR=#f00000>16.11.99</FONT></H3>
<p>


<H2>Cours</H2>


<H3>Encore quelques détails sur la gestion de la pile des données</H3>

<SPAN class=ib>Plus généralement : faut-il encore discuter la machine virtuelle? Oui, mais pour aborder quelques détails concernant le code et le runtime, il faut d'abord traiter les problèmes d'analyse syntaxique, les attributs des objets qui constituent la représentation intermédiaire, etc. Pour l'instant notre code est trop "manuel". <I>Stay tuned</I>, aujourd'hui nous traitons à peine quelques techniques d'optimisation de bas niveau.</SPAN>
<p>

Faut-il détruire les items sur la pile de données un par un, par <TT>pop</TT> ou en les consommant par les opérateurs? Ceci n'est pas commode, imaginez une procédure qui prend 4 paramètres, et utilise le deuxième plusieurs fois, et les autres dans le plus grand désordre. Manuellement nous pouvons jouer avec <TT>exch</TT>, etc., mais il serait préférable d'avoir une technique mieux adaptée à la compilation mécanique des procédures écrites dans un langage structuré. On peut en principe procéder de manière suivante, si le code est généré par une procédure de compilation qui possède toutes les informations sur le contexte de l'exécution :
<UL type="disc">
<LI> Un appel n-aire, disons : <B>callproc f(a,b,c)</B> où <B>a,b,c</B> sont des expressions quelconques, exécute normalement l'évaluation des arguments et les empile. Ensuite on empile l'information sur la modification de la pile, p. ex. le nombre 3, ou l'adresse du sommet précédent de la pile. (Le second choix est plus efficace, pas d'arithmétique à faire, mais il peut consommer un peu plus de mémoire, car un petit entier peut être fusionné avec d'autres informations).

<LI> Si l'on veut, on peut empiler également l'adresse de retour sur la pile des données. Tout cela, plus - éventuellement un peu de place supplémentaire pour les variables locales, s'appelle parfois le <I>stack frame</I>, ou l'<I>instance d'activation</I>. L'usage d'une pile des retours séparée est bon pour le déboguage et pour le code manuel style FORTH ou Postscript, mais normalement les deux piles sont synchrones.

<LI> L'allocation des variables locales d'une procédure se fait normalement par elle même, car le module appelant peut être compilé séparemment, et ignorer le contenu de la procédure appelée. Donc, la procédure appelée peut gérer les modifications du pointeur "sommet" de la pile, le module appelant place les arguments en indéxant les éléments de la pile "au dessus" du sommet (ce qui nécessite l'usage des tableaux, avec les listes ça ne marcherait pas).

<LI> Ceci est à peu-près la philosophie du Pascal. Par contre, en C, une procédure <EM>ne sait forcément pas avec combien d'arguments elle sera appelée</EM>, donc le module appelant
modifie lui aussi la position du sommet.

<LI> Toute référence aux paramètres de la procédure appelée se fait par l'équivalent de <B>(index)</B>, la commande qui accède à la pile comme à un tableau et empile l'argument désiré. On peut le mettre aussi dans un registre accessible directement.

<LI> Le retour restore une seule fois le sommet de la pile des données. Si on a stocké sur cette pile l'adresse de retour, on le récupère.
</UL>

Dans les temps glorieux des langages comme Algol60 et 68, et plus tard avec le Pascal, on a noté un sérieux problème avec les variables non-locales. Les variables globales sont des entrées dans le tableau-environnement global, des simples indices absolus. Mais si on peut définir les procédures imbriquées, alors une variable non-locale peut appartenir à une instance d'activation supérieure. Le compilateur doit administrer deux chaînes de pointeurs : dynamique, qui représente l'ordre des appels, et statique - l'imbrication, le contexte lexical (objet <TT>b</TT> local à <TT>a</TT>). Si on déclare
<PRE>
proc a
 var x
 proc b
   référence non-locale à x
 endproc b
  référence locale à x
endproc a
</PRE>
la référence locale adresse la pile selon l'ordre établi par le compilateur. Mais la référence non-locale est plus tordue. Si la procédure <TT>b</TT> "appartient" à <TT>a</TT>, alors elle peut être appelée <EM>uniquement dans son contexte</EM>, par <TT>a</TT> même, ou par une autre procédure appelée par <TT>a</TT>. Donc, l'instance d'activation de <TT>a</TT> se trouve sur la pile, comme il faut.
<p>

(<I>Vous me suivez encore?...</I>)
<p>

Donc, <TT>x</TT> a été déjà empilé (possède sa "niche" sur la pile). C'est bien. Mais cette niche se trouve dans une instance d'activation précédente. Le code doit suivre le lien statique (lexical) entre la procédure courante (<TT>b</TT>) et <TT>a</TT>, l'identifier, et ensuite suivre les liens dynamiques (l'ordre d'appels et de l'empilement) pour trouver <TT>x</TT>.
<p>

Pour éviter une perte de temps considérable pour le décodage de telles variables, les compilateurs souvent manipulent un tableau spécial, le "<I>display</I>", qui trace les indirections des variables non-locales de manière la plus efficace possible. <p>

(<I>Vous vous sentez perdus?</I> Ne vous inquiétez pas, c'est normal, vous n'êtes pas seuls. Les compilateurs des langages impératifs, écrits dans des langages impératifs sont <B>toujours</B> longs et pas très lisibles.)
<p>

Ces difficultés sont une des raisons pour l'interdiction des imbrications dans Fortran, BCPL et "C". Dans "C++" nous avons d'autres non-localités, l'imbrication des classes, mais il est trop tôt pour discuter ici leur implantation. Cependant, dans des langages fonctionnels qui restent pour nous des paradigmes de simplicité, la question de non-localité revient. En Scheme, ML, Haskell, etc. on peut introduire par <B>let</B> ou une construction pareille (p. ex. <B>where</B>), un nombre quelconque de définitions internes, y compris les définitions fonctionnelles qui peuvent "piéger" des objets extérieurs, formant ainsi des fermetures. Comment les implanter de manière <SPAN class=ib>lisible</SPAN>, simple, même si non-optimale? On a besoin de ça même pour le simple cas d'applications partielles. Nous allons répondre à ces questions un peu plus tard.


<H3>Constantes dans le code</H3>

Rappelons que le code PostScript peut contenir les commandes et les constantes, p. ex. <TT>{... 1 dup ...}</TT>. Nous avons renoncé d'exploiter cette possibilité, ainsi la machine virtuelle n'a pas besoin de se poser des questions genre "qu'est-ce que cet objet dans le programme? Une comande ou une donnée?" Nous avons uniquement des exécutables. Alors, pour empiler une constante, on exploite la fermeture (application partielle) comme <TT>ldc (F 5.0)</TT>, etc. Ceci est facile, lisible, efficace... Mais ... <p>

... on a besoin d'un langage fonctionnel moderne pour implanter notre machine. En "C" toute commande peut être représentée par un pointeur sur la fonction correspondante (ce qui au niveau d'implantation est équivalent à un pointeur quelconque, par exemple un pointeur sur une donnée numérique), mais il n'y a pas de mécanismes permettant de créer dynamiquement les fermetures. Donc, pour chaque constante il faudrait prévoir la compilation d'<SPAN class=ib>une procédure d'empilement dédiée</SPAN>. Ceci n'est ni élégant ni efficace. Mais Haskell n'est pas notre langage d'implantation idéal, surtout si nous voulons faire un petit compilateur/interprète integré à une application. C'est mon langage préféré pour enseigner la compilation (avec les excursions dans le monde du Prolog...), mais un jour nous pourrons être obligés de retourner à C++. Alors, pouvons-nous avoir le beurre et l'argent du beurre?
<p>

La solution est connue déjà depuis le temps du langage FORTH. Imaginez la transformation de notre code : <TT>[... , ld 5, ...] ==&gt;&gt;  [... , ldv, 5, ...]</TT>. On a fait un pas vers l'arrière, on a réintroduit les constantes dans le code, mais cette fois <EM>la constante ne sera pas empilée par la machine virtuelle.</EM> En fait, la machine virtuelle <SPAN class=ib>ne verra jamais cette constante</SPAN>. C'est la commande <TT>ldv</TT> qui a l'accès au code en train d'exécution (par la pile des retours, ou directement), qui va traiter cet objet, et va l'empiler. La machine (la boucle principale) récupère le contrôle avec le "program counter" positionné derrière la constante. Pour réaliser cela en Haskell il faut malheureusement changer (un peu !) la spécification de notre machine (mais pas son code !), sinon, on aura des problèmes de typage. Au lieu de spécifier <TT>type Code=[CodeItem]</TT> où
<PRE>
type CodeItem = (Rstack -&gt; Dstack -&gt; (Rstack,Dstack))
</PRE>
(voir le <A HREF="comres5.html#codspec">cours précédent</A>), il faut prévoir tout simplement une structure un peu plus riche, avec des alternatives, par exemple
<PRE>
type Cmnde = (Rstack -&gt; Dstack -&gt; (Rstack,Dstack))
data CodeItem = Cm Cmnde | Cv Value
</PRE>
Le code de la machine virtuelle au lieu de prendre <TT>instr</TT> comme un élément de la liste-code, y trouve <TT>(Cm instr)</TT>, c'est tout. Le code peut contenir le segment <TT>[ ..., Cm ldv, (Cv (F 4.5)), ...]</TT>, décidemment un peu rébarbatif à cause du balisage multiple, mais <EM>soulignons</EM> : un tel code est conçu pour être régulier et pour faciliter le travail du compilateur dans un contexte où le typage fort oblige. Normalement un être humain n'aura rien à voir avec la création ou gestion d'un tel code. La nouvelle primitive <TT>ldv</TT> est (comme toujours) assez courte :
<PRE>
ldv p ((Cv datum):rcode) :&gt; rpile) =
  (datum:p,rcode :&gt; rpile)
</PRE>


<H3>Co-procédures</H3>

Les fonctions (procédures) ne sont pas le seuls "blocs", entités exécutables composites, même si on enseigne très rarement une autre chose quelconque. Un bon contre-exemple ce sont les processus qui tournent sous le contrôle du système d'exploitation (et les processus qui en font partie). Si ils tournent sur un seul processeur, naturellement le temps doit être partagé. Les processus s'appellent réciproquement, ils communiquent, mais cette communication n'est pas hiérachisée comme les appels procéduraux : A appelle B, qui appelle C, qui appelle A, ... - ceci aurait empilé les adresses de retour et forcé les retours dans l'ordre inverse. Mais ici, ou dans un programme de simulation, ou dans un jeu A passe le contrôle à B, qui peut le passer à A, etc. comme une balle de ping-pong. Un module A suspend son activité en appelant l'autre, B, mais le nouveau "appel" de A par B est équivalent au "retour".
<p>

<B><I>Un autre exemple.</I></B> Une application possède trois modules en pipe-line : le "lecteur" qui effectue l'acquisition et le prétraitement des données, l'"exécuteur" qui les digère et transforme, et l'"afficheur" qui sort les résultats. Ceci peut être un compilateur, avec des modules comme l'analyseur lexical (scanneur), le parseur, l'analyseur sémantique, le générateur du code intermédiaire, l'optimiseur, et finalement l'assembleur du code-cible, qui exporte les binaries compilées. On peut imaginer le transfert des données séquentiel, par exemple <TT>afficheur (optimiseur (gencode (parseur (lexeur flot))))</TT> ou mieux, la composition
<TT>afficheur . optimiseur . gencode . parseur . scanneur</TT> agissant sur le flot d'entrée. <EM>Ceci n'est pas une bonne idée dans un langage strict</EM>, car le scanneur doit terminer son travail, passer la totalité du flot intermédiaire au parseur, ensuite au vérificateur des types etc. Si à ce moment-là on découvre une erreur, tout le travail préalable (imaginez l'analyse lexicale d'un programme de 30 000 lignes, avec la création du tableau des symboles...) sert à rien ! (Et le fichier intermédiaire non plus, sauf si on veut le parcourir pour le déboguage.)
<p>

Mais avec un langage paresseux le caractère d'exécution change drastiquement. Chaque module fait le strict minimum. Le scanneur passe le premier lexème au parseur. Si le parseur veut un autre en lisant son flot d'entrée, le scanneur rédemarre. Grâce aux flots de données paressux, les procédures enchaînées de cette manière se comportent comme des co-procédures, entitées indépendantes, communiquantes. On peut faire une chose pareille avec le pipelining d'Unix : au début le parseur démarre, mais il ne fait rien, il attend les données. Le scanneur marche indépendamment, mais son flot de sortie remplit vite le buffer, et le scanneur suspend son activité. Le parseur doit vider ce buffer, consommer les données, remplir son buffer de sortie, et quand il y a de la place dans son tampon d'entrée, le scanneur rédemarre.
<p>

Les flots paresseux, les buffers FIFO etc. - tout ceci est <I>une vision possible</I> de la co-procéduralisation. Mais on peut imaginer aussi un protocole de transfert de contrôle comme ci-dessous, comparez les appels procéduraux, avec le ping-pong co-procédural entre deux objets exécutables :
<p>

<CENTER><IMG SRC="corout.gif" WIDTH="497" HEIGHT="477" ALT=""></CENTER>
<p>
Les lignes rouges correspondent aux retours. Chaque unité peut naturellement avoir des boucles internes. En fait, une boucle est une sorte d'appel co-procédural d'un module par lui-même, car pour les appels terminaux il n'y a pas de retour.
<p>

Est-il possible de représenter les co-procédures, et la commande primitive <TT>resume</TT> adaptées à notre machine virtuelle? En principe oui, mais les modifications sont profondes. Les "retours" ne sont plus stockés sur une pile. Chaque module possède <B>une instanced'activation</B> à la fois, on doit sauvegarder les points de suspension statiquement, avec le code. L'exécution du <TT>resume B</TT> (avec le code-cible B empilé, ou passé en argument de <TT>resume</TT>) accède à B, trouve le dernier point de suspension, et branche. Nous essairons (peut-être) réaliser cela en TD, mais <I>a priori</I> l'affaire est délicate : nous travaillons dans un contexte fonctionnel pur, et nous n'avons pas le droit de modifier le code (modifier la cellule qui contient le point de rédemarrage). On peut discuter cette catégorie de problèmes, y compris autres formes de <B>goto</B> à travers les continuations. Cela viendra.



<H3>Deux mots sur le <SPAN class=ib>threaded code</SPAN></H3>

Imaginez un programme <I>compilé</I> qui doit exécuter des instructions plutôt compliquées, par exemple évaluer une expression algébrique formelle, manipuler les objets très exotiques, etc. Dans un module utilisateur on trouve rarement les primitives, la plupart des primitives susceptibles d'être compilées <I>in-line</I> et transformées en code assembleur se trouvent dans les librairies du <I>run-time</I>. Donc un programme assez typique (avec un peu d'exagération) aura la forme
<PRE>
 call f1
 call f2
 ...
 call fx
 ...
</PRE>
où les <TT>f_n</TT> sont les procédures primitives du langage, codées à un niveau plus bas, et stockées dans des librairies. Appel, etour, appel, retour, ... - ceci n'est pas tellement plus efficace que notre machine virtuelle qui exécute le code
<PRE>
 f1
 f2
 ...
 fx
 ...
</PRE>
et qui perd un peu plus de temps par rapport au hardware, car ce dernier décode la primitive <TT>call</TT>, ffectue l'adressage, et incrémente le compteur de programme en parallèle. Cette perte n'est pas très grande, pas de décodage de <I>byte-codes</I> à faire, quelques indirections ne coûtent pas beaucoup, et le code est plus compacte.
<p>

Mais on peut faire un peu mieux ! La séquence : (retour; call suivant) peut en principe être éliminée, et transformée automatiquement en appel terminal, ou goto : (goto suivant), composé éventuellement avec la gestion des arguments, ce qui est trivial pour une machine à pile. <I>On ne peut</I> faire cette optimisation si le code est compilé pour une architecture hard, de bas niveau, car une procédure compilée séparemment ne sait pas où elle devra brancher. Et si elle est appelée plusieurs fois? Il faudrait s'assurer que chaque procédure connaisse le code "devant son appel", et puisse récupérer l'adresse de la commande suivante à exécuter. Mais la totalité de contrôle appartient à la gestion hard du compteur-programme, et celui-ci n'est pas directement accessible par le code utilisateur, autrement que par l'exécution d'une instruction d'adressage.
<p>

Mais dans notre environnement interprété nous pouvons nous assurer que toute primitive effectue cet "incrémentation du compteur" (passe au CodeItem suivant), et chaque procédure utilisateur se termine non pas par <TT>ret</TT>, mais par une nouvelle primitive <TT>next</TT>, qui réalise cet enchaînement. Ainsi la boucle principale, "la" machine cesse d'exister !
<p>

Ce protocole porte le nom de <I>threaded code</I> ("code enfilé"??), et il mérite d'être plus connu. Nous allons -si le temps nous le permet - retourner à tout cela après avoir discuté l'usage des continuations, qui est une vision fonctionnelle, de haut niveau du transfert de contrôle. Les continuations nous permettront aussi de réaliser les co-procédures.

<p>
<!-- ********************************************************* --><p>
<CENTER><IMG SRC="../icons/rainbow.gif" WIDTH="576" HEIGHT="9" ALT="">
</CENTER>
<p>


<H3>Le parsing dans notre philosophie fonctionnaliste</H3>

Nous avons déjà abordé la technique d'analyse syntaxique utilisant le prédicat non-déterministe en Prolog. Rappelons <A HREF="comres4.html#algram">notre grammaire</A> qui décrit les expressions arithmétiques :
<PRE class=he>
expr ::= terme | expr + terme
terme ::= facteur | terme * facteur
facteur ::= atome | ( expr )
</PRE>
<P>

Voici le parseur non-déterministe qui correspond à cette grammaire. Nous avons souligné qu'il était mauvais ! (Sans compter quelques fautes de frappe honteuses qui ont finalement été corrigées...)
<PRE>
expr(LT,LR,add(X,Y)) :- expr(LT,['+'|LQ],X),
                        terme(LQ,LR,Y).
expr(LT,LR,X) :- terme(LT,LR,X).

terme(LT,LR,add(X,Y)) :- terme(LT,['*'|LQ],X),
                         facteur(LQ,LR,Y).
terme(LT,LR,X) :- facteur(LT,LR,X).

facteur(['('|LT],[')'|LR],R) :- expr(LT,LR,R).
facteur([X|LR],LR,X):-atomeLegal(X).
</PRE>

Il ne s'agit pas de l'inefficacité résultant de non-déterminisme. Ceci c'est le moindre ne nos soucis. Le prédicat <TT>facteur</TT> est correcte, mais <TT>expr</TT> et <TT>terme</TT> plantent misérablement à cause de la récursivité à gauche. La solution 
<PRE>
expr(LT,LR,add(X,Y)) :- terme(LT,['+'|LQ],X),
                        expr(LQ,LR,Y).
</PRE>
serait correcte, mais pour la soustraction et division il faut respecter la convention de l'associativité à gauche. Et le flot d'entrée <TT>LT</TT> reste le même, le parseur ne progresse pas ! La première solution, avec <TT>append</TT> était correcte, mais pas très pratique, ici l'inefficacité technique : l'usage de l'append non-déterministe dans un contexte récursif était un <I>overkill</I>... 
<p>

La technique de normalisation de Greibach ne sera pas présentée de manière trop formelle. Dans notre cas concret <I>une</I> clause est récursive à gauche. Appliquons donc la transformation suivante. La production
<PRE class="he">
expr ::= terme | expr + terme
</PRE>
passe à
<PRE>
expr ::= terme termlist
termlist ::= EPS | + terme termlist
</PRE>
où EPS est la chaîne vide. Le non-terminal <TT>terme</TT> subit le même sort. Mais cette transformation n'est pas inoffensive si le parseur doit non pas seulement effectuer le filtrage et répondre oui/non à la question concernant la légalite de l'expression parsée, mais <SPAN class=ib>construire l'arbre correspondant</SPAN>.
<p>

Jusqu'à présent le visage constructeur de chaque non-terminal était assez simple - ils correspondaient aux sous-arbres. Un terme, une sous-expression, un atome - tout cela sont des structures de données Prolog, des noeuds dans l'arborescence syntaxique. <EM>Mais <TT>termlist</TT> ne l'est pas !</EM> Le non-terminal <TT>termlist</TT> correspond au <I>contexte droit</I> d'un terme : c'est "quelque chose" qui commence par le caractère "+", et donc c'est un fragment d'arbre avec la branche gauche manquante. L'expression <B>a + b + c</B> peut être représentée par le graphe suivant, où la ligne bleue encercle le termlist qui suit le premier terme <B>a</B>.
<P>

<CENTER><IMG SRC="congraf.gif" WIDTH="356" HEIGHT="354" ALT="">
</CENTER>
<p>

Nous allons compléter la construction de "quelque chose" par <TT>termlist</TT>, en lui fournissant le contexte manquant. Voici le prédicat <TT>expr</TT> :
<PRE>
expr(LT,LR,Res) :- 
  terme(LT,LQ,X), termlist(LQ,LR,X,Res).

termlist(['+'|LT],LR,Cx,Res) :- 
  terme(LT,LQ,Cy), termlist(LQ,LR,add(Cx,Cy),Res).
termlist(LT,LT,Cx,Cx).
</PRE>
Le facteur est construit de la même manière. Il faut obligatoirement comprendre cette construction. <p>

Nous allons maintenant passer à la construction générale des parseurs non-déterministes descendants (leur optimisation viendra plus tard). La stratégie descendante signifie, que l'arbre syntaxique est bâti à partir de sa racine. Le symbole de départ de la grammaire de notre langage (ici : <TT>expr</TT>) "s'applique" au flot de données (programme-source), et initie la construction de l'arborescence, en appelant ses "esclaves", les composantes qui doivent constituer les branches de l'arbre. Plus tard nous parlerons de la stratégie ascendante, qui peut être beaucoup plus efficace, mais qui est toujours un peu lourde à expliquer.

<!-- ********************************************************* --><p>
<CENTER><IMG SRC="../icons/limarro.gif" WIDTH="576" HEIGHT="9" ALT="">
</CENTER>
<p>

<p>
<H2>TD</H2>
<p>
<H3>Encore un exercice sur le non-déterminisme</H3>
<p>

(<I>En fait, deux exercices, principalement pour l'entraînement</I>.) Comment construire le "<I>powerset</I>" d'un ensemble, c'est-à-dire, l'ensemble de tous les sous-ensembles? La technique non-déterministe peut être exprimée de façon suivante : On construit un élément quelconque de l'ensemble-solution, ou <SPAN class=ib>un sous-ensemble quelconque</SPAN>. On parcourt l'ensemble-source, et pour chacun de ses éléments on décide : accepter ou rejeter. Accesoirement nous pouvons mémoriser aussi l'état de l'ensemble d'origine après la sélection d'un ou plusieurs de ses éléments. La solution en Prolog est (comme <SPAN class=ib>tout</SPAN> dans ces notes ...) très courte. Le prédicat obéit au protocole d'appel suivant : <B>pset(Source,sousEnsemble,Reste)</B>.
<PRE class="he">
pset([],[],[]).
pset([X|Q],[X|L],R) :- pset(Q,L,R).
pset([X|Q],L,[X|R]) :- pset(Q,L,R).
</PRE>
ce qui donne les résultats suivants :
<PRE>
?- pset([a,b,c,d],L,R).
L=[a,b,c,d],
R=[];

L=[a,b,c],
R=[d];

L=[a,b,d],
R=[c];

L=[a,b],
R=[c,d];

L=[a,c,d],
R=[b];

L=[a,c],
R=[b,d];

L=[a,d],
R=[b,c];

L=[a],
R=[b,c,d];

L=[b,c,d],
R=[a];

L=[b,c],
R=[a,d];

L=[b,d],
R=[a,c];

L=[b],
R=[a,c,d];

L=[c,d],
R=[a,b];

L=[c],
R=[a,b,d];

L=[d],
R=[a,b,c];

L=[],
R=[a,b,c,d];

no
</PRE>
<EM>(Cet algorithme n'a pas été présenté en TD, mais sa connaissance peut être exigée.)
</EM> 
<p>

La construction en Haskell utilise toujours les mêmes "vieux trucs", avec la liste vide pour l'échec, concaténation pour l'alternative, et la manipulation d'une solution non-déterministe par <TT>map</TT>. (Parfois il faut aplâtir le résulat renvoyé par <TT>map</TT>, ou utiliser <TT>mapcon</TT> - toujours quand une opération qui produit un résultat non-déterministe agit sur l'argument qui est déjà nondéterministe, mais pas ici.)

<PRE>
pset [] = [([],[])]
pset (x:xq) = let lr = pset xq in
 [(x:l,r) | (l,r)&lt;-lr] ++ [(l,x:r) | (l,r)&lt;-lr]
</PRE>
ou pour varier nous avons utilisé la notation de "compréhensions" au lieu de <TT>map</TT>. Vous <SPAN class=ib>devez</SPAN> apprendre le rapport entre les deux notations. 
<p>

Nous avons traité les <SPAN class=ib>combinaisons</SPAN>, un algorithme qui trouve les sous-ensembles d'une collection de taille figée, disons N. Bien sûr, N doit être non-négatif, et inférieur ou égal à la taille de la liste-source. voici la solution en Prolog, le prédicat <B>comb(L,L,A,B)</B>, ou le premier argument c'est la liste-source, le second est le nombre d'éléments choisis, le troisième et le quatrième sont des paramètres de sortie : la liste des éléments choisis, et la liste des rejets.
<PRE class="he">
comb(L,0,[],L) :- !.
comb([X|Q],N,[X|A],B) :- M is N-1, 
   comb(Q,M,A,B).
comb([X|Q],N,A,[X|B]) :- comb(Q,N,A,B).
</PRE>
<EM>Attention !!</EM> Notez la première ligne. Dans notre solution discutée en classe, elle avait la forme <B>comb(L,0,[],L).</B> Ceci est presque OK, le seul problème que j'ai voulu "cacher" temporairement est le fait que cette clause n'est pas exclusive, elle se recouvre partiellement avec la troisième ! Le résultat est que quelques solutions sont bêtement répétées, le prédicat produit les doublons. Le point d'exclamation est l'opérateur "cut", ou "coupe-choix". Sa sémantique est la suivante : si le cut est exécuté dans le contexte d'une clause, le choix de cette clause est définitive, tout non-déterminisme, la possibilité du backtracking en cas de non-acceptation de cette clause est éliminée.
<p>

Le cut sera présenté comme il faut en cours de Prolog, mais il faut savoir que de la perspective de programmation logique, le cut appartient au Côté Obscure de la Force... Si on peut l'éviter, tant mieux pour la clarté du programme. Ici nous pouvons aisément résoudre le problème de manière plus "catholique", (orthodoxe si on veut...) mais légèrement moins efficace, car il y a maintenant des comparaisons arithmétiques visiblement redondantes, dont le seul but est d'ajouter une contradiction vis-à-vis le cas N=0, et éviter l'usage du cut :
<PRE class="he">
comb(L,0,[],L).
comb([X|Q],N,[X|A],B) :- N&gt;0, M is N-1, 
   comb(Q,M,A,B).
comb([X|Q],N,A,[X|B]) :- N&gt;0, comb(Q,N,A,B).
</PRE>

La solution en Haskell sera présentée doucement, avec beaucoup de commentaires, car j'ai vu vos visages distordus par les souffrances inimaginables, mais pour apprendre le codage des algorithmes non-déterministes il faut faire quelque chose soi-même (sans parler de la nécessité de reviser les notes de CM/TD de temps en temps...)
<p>
La première clause est triviale :
<PRE>
comb l 0 = [([],l)]
</PRE>
Rappelons pour la n-ième fois qu'une procédure non-déterministe renvoie une <I>liste de solutions</I>, ou la liste vide en cas d'échec. Pour n=0 une solution existe. Nous n'avons pas besoin de spécifier la condition <TT>n &gt; 0</TT> pour les autres clauses (sauf si on veut protéger la fonction contre les mauvais paramètres ...), car Haskell <I>n'est pas un langage non-déterministe</I>, et si une clause est acceptée, nous ne pouvons <I>rien</I> faire pour demander une autre solution. Une pseudo-traduction de la première clause Prolog donne
<PRE style="color:#a00000">
comb (x:q) n = ((x:a),b) where (a,b) = comb q (n-1)
</PRE>
Mais <TT>(a,b)</TT> est <I>une</I> instance, une solution concrète, tandis que <TT>comb</TT> 
doit renvoyer une liste de solution, donc, il faut utiliser <TT>map</TT>. Voici la solution, dûment testée, qui contient aussi le second membre de l'alternative (la troisième clause), qui est également calculé et concaténé avec la deuxième clause.
<PRE>
comb (x:q) n = [(x:a,b) | (a,b) &lt;- comb q (n-1)] ++
  [(a,x:b) | (a,b) &lt;- comb q n]
</PRE>
Rappelons (pour la dernière fois !) que la "compréhension" <TT>[f x | x &lt; l]</TT> est le synonyme de <TT>map f l</TT>, et que cette notation permet d'ajouter au <I>mapping</I> le filtrage - la possibilité d'éliminer quelques éléments de la liste transformée.
<p>


<EM>Ceci n'est pas tout</EM>. En traduisant un programme de Prolog on oublie parfois que l'échec, volontaire ou non, dû à l'échec de l'unification (filtrage) des paramètres n'est pas grave en Prolog, mais dans un langage classique (déterministe) c'est un coup mortel (erreur d'exécution). <B>Il faut obligatoirement insérer une clause "protectrice"</B> dans notre solution qui empêche la tragédie si on essaie de sélectionner quelque chose depuis une liste vide. Voici la solution complète :
<PRE>
comb l 0 = [([],l)]
comb [] _ = []
comb (x:q) n = [(x:a,b) | (a,b) &lt;- comb q (n-1)] ++
  [(a,x:b) | (a,b) &lt;- comb q n]
</PRE>

<H3><A HREF="comint6.html">Intermezzo : numéraux de Church</A></H3>

J'ai mis toute cette discussion fonctionnaliste sur une page séparée.

<H3>Un parseur en Haskell</H3>
<p>

Revenons à nos expressions algébriques, mais pour ne pas s'égarer, simplifions un peu la grammaire. Nos expressions contiennent des atomes alphanumériques, composés d'une seule lettre chacun. On peut utiliser les parenthèses, et l'opérateur d'addition, c'est tout. <EM>Mais dans cet exercice l'associativité de l'opérateur "+" est à droite !</EM> L'expression "<TT>a+b+(c+d)+e</TT>" doit être parsée comme
<CENTER><IMG SRC="arbrs.gif" WIDTH="306" HEIGHT="260" ALT=""></CENTER>
<p>
Voici la grammaire, et le code Prolog du parseur :
<PRE class="he">
expr ::= terme | terme + expr
terme ::= atome | ( expr )

expr(LT,LR,add(X,Y)) :- terme(LT,['+'|LQ],X), expr(LQ,LR,Y).
expr(LT,LR,X) :- terme(LT,LR,X).
terme(['('|LT],LR,X) :- expr(LT,[')'|LR],X).
terme([X|Q],Q,X):-atomeLegal(X).
  <EM>et pour tester</EM>
liste(['a','+','b','+','(','c','+','d',')','+','e','zzzz']).
</PRE>
Voici la requête, et la réponse :
<PRE>
?- liste(L),expr(L,LQ,X).
L=[a,+,b,+,'(',c,+,d,')',+,e,zzzz],
LQ=[zzzz],
X=add(a,add(b,add(add(c,d),e)))

yes
</PRE>
OK, OK, on a triché. Ce n'est pas la réponse complète. ce que l'on obtient réellement se présente comme ça, si on définit accessoirement le prédicat <TT>atomeLegal</TT> qui empêche qu'une parenthèse soit considérée comme un atome :
<PRE>
?- liste(L),expr(L,LQ,X).
L=[a,+,b,+,'(',c,+,d,')',+,e,zzzz],
LQ=[zzzz],
X=add(a,add(b,add(add(c,d),e)));

L=[a,+,b,+,'(',c,+,d,')',+,e,zzzz],
LQ=[+,e,zzzz],
X=add(a,add(b,add(c,d)));

L=[a,+,b,+,'(',c,+,d,')',+,e,zzzz],
LQ=[+,'(',c,+,d,')',+,e,zzzz],
X=add(a,b);

L=[a,+,b,+,'(',c,+,d,')',+,e,zzzz],
LQ=[+,b,+,'(',c,+,d,')',+,e,zzzz],
X=a;

no
</PRE>
Normalement ceci est le prix à payer pour le non-déterminisme dans ce contexte - on obtient toutes les réponses, y compris les réponses partielles, trop courtes.
<p>

Le même phénomène peut se produire en réalisant cet algorithme non-déterministe dans un autre langage. Mais Haskell et autres <EM>langages paresseux</EM> (malheureusement il n'y en a pas beaucoup...) offre quelques avantages, à condition que la solution la plus longue se trouve au début de la liste : collection de réponses. <SPAN class=ib>On n'a pas besoin d'aller chercher plus loin !</SPAN>. La sémantique paresseuse suspend la création d'autres réponses, et le temps de parsing est abrégé. C'est pour cela qu'il faut traiter la réponse la plus longue d'abord. Dans des cas vraiment simples, comme notre exemple, le non-déterminisme du résultat peut être éliminé trivialement - il suffit de <SPAN class=ib>forcer</SPAN> la recherche de l'expression qui suit le caractère '+', et de ne jamais retourner l'expression tronquée au premier terme, si ce caractère est présent.
<p>

Donc, nous allons traduire notre parseur en Haskell. D'ailleurs, vous pouvez être presque sûrs d'avoir un sujet d'examen consacré à la construction des parseurs en Haskell.
<p>

Les structures de données qui représentent les arbres appartient au type suivant :
<PRE>
data Xpr = F Char | Sum Xpr Xpr
</PRE>
(Notez le changement de notation p. rapport aux TD).

Commençons par une "traduction aveugle" de la clause récursive, qui tient compte uniquement des particularités syntaxiques :
<PRE class="rp">
expr l = let a@(x,lq)=terme l 
         in if hd lq == '+' then
               let (y,lr)=expr (tl lq) in (Sum x y,lr)
            else a
</PRE>
où <TT>hd</TT> est la tête de la liste, et <TT>tl</TT> - sa queue :
<PRE>
hd (x:_) = x
tl (_:q) = q
</PRE>
Notre <TT>expr l</TT> est naturellement erroné, car le <TT>terme</TT> renvoie déjà une liste de réponses, et non pas une seule, une paire <TT>(a,b)</TT>. Donc, <TT>lq</TT> existe en plusieurs exemplaires, et aux tous, il faudra appliquer <TT>expr</TT>, qui est non-déterministe elle aussi. Nos voyons enfin le même phénomène qu'en cas de permutations (si parmi vous quelques uns se sont posés la question qu'est qu'il y avait de commun entre la génération de permutations et la compilation, voici la réponse). Il faudra appliquer <TT>map</TT> deux fois, et aplâtir le résultat. On gère ainsi automatiquement le cas où déjà le premier terme échoue et renvoie la liste vide.  La fonctionnelle <TT>map</TT> propage l'échec automatiquement. En TD (premier groupe) nous avons essayé de coder ces décisions manuellement: si la réponse renvoyée par le premier terme est vide alors ..., sinon, on cherche l'expression, à condition de trouver le caractère '+', etc. Voici la solution. Le parseur <TT>terme</TT> est particulièrement simple. Si l'expression commence par la parenthèse, la seule chose à faire est de localiser la parenthèse fermante par le parseur <TT>expr</TT>, aucun autre non-déterminisme n'intervient. Sinon, on découpe le premier item ; la solution est déterministe.
<PRE>
terme ('(':l) =
 [(e,lr)|(e,c:lr) &lt;- expr l, c==')']
terme (x:q) = [(F x,q)]
terme [] = []   -- au cas où - (normalement jamais)
</PRE>
En fait, les deux dernières clauses <SPAN class=ib>doivent</SPAN> fusionner en une seule, la séparation de la tête, à condition que cette tête soit un atome légal. Le flot peut ne jamais être vide, au moins on peut toujours mettre à la fin un caractère de terminaison (EOF, ou ASCII \0, etc.) qui n'est pas considéré comme un atome légal
<p>

Voici le parseur <TT>expr</TT> :
<PRE>
expr l = 
 let s=terme l in
  concat [ [(Sum x y,lr) | (y,lr)&lt;-expr lq'] 
           | (x,c:lq')&lt;-s, c=='+']
    ++ s
</PRE>
La compréhension doit être lue de l'extérieur vers l'intérieur. Le premier <TT>terme</TT> retourne la liste d'objets, tous destructurés comme <TT>(x,c:lq')</TT>. Le filtrage <TT>c=='+'</TT> établit le contexte où ce terme est suivi par d'autres, permet d'appliquer à <TT>lq'</TT> le parseur <TT>expr</TT> et assembler le noeud de l'arbre (la compréhension interne). Dans tous les cas on garde le premier terme comme une solution possible - la dernière concaténation s'en charge. Le parsing de "a+b+(c+d)+e" donne (après la définition de la classe Show pour les arbres, ce que je cache de vos sensibles yeux) :
<PRE>
[("add(a,add(b,add(add(c,d),e)))",  ";zzzzz"),
 ("add(a,add(b,add(c,d)))",  "+e;zzzzz"),
 ("add(a,b)",  "+(c+d)+e;zzzzz"),
 ("a",  "+b+(c+d)+e;zzzzz")]
</PRE>
Nous avons essayé d'appliquer la philosophie non-déterministe de façon la plus mécanique possible. Mais il est évident, que sur le plan pratique le parseur peut être trivialement optimisé, et rendre seulement la solution la plus longue : si la recherche du caractère '+' (et de l'expression suivante) réussit, on ne concatène pas le résultat final avec la solution partielle correspondant au premier terme, cette dernière est rejetée. Voici le parseur optimisé :
<PRE>
expr l = 
 let s=terme l 
     m=concat [[(Sum x y,lr)|(y,lr)&lt;-expr lq']
                 |(x,c:lq')&lt;-s, c=='+']
 in if m==[] then s else m
</PRE>
Ici seulement la solution la plus longue est retenue. <EM>Attention, SVP.</EM> L'usage d'un langage typé cache parfois des petits problèmes. L'expression <TT>m==[]</TT> n'est pas entièrement triviale, le compilateur doit savoir quel est le sens de l'opération "==" entre les arbres. Vous trouvez les détails dans la documentation de Haskell/Hugs, trouvez SVP la description de la directive <TT>deriving</TT> qui simplifie (parfois élimine) des définitions de ce genre. Sinon, nous pouvons toujours ajouter les définitions suivantes, où les mordus trouveront aussi la fonction d'affichage des arbres :
<PRE>
instance Eq Xpr where
 F x == F y = x==y        -- Feuilles identiques
 Sum x y == Sum a b = x==a && y==b
 _ == _ = False
 
instance Show Xpr where
 showsPrec _ (F c) = showChar c
 showsPrec _ (Sum x y) = 
  showString "add(" . shows x . showString "," . 
                      shows y . showString ")"
</PRE>
Notez que la sérialisation de l'affichage d'une structure composite, sa transformation en chaîne se réduit simplement à la composition fonctionnelle. Mais ceci signifie que l'expression "<TT>shows x</TT>", etc., <I>retourne une fonction</I>. En fait, c'est l'application partielle ; la forme <TT>shows x l</TT> transforme <TT>x</TT> en chaîne, et concatène le résultat avec <TT>l</TT>. Nous avons déjà discuté l'applicatation de cette technique pour l'optimisation de l'aplâtissement des arbres. Elle est assez universelle.
<p>


<H3>Parseur Greibach-normalisé</H3>

Revenons aux "vrais" opérateurs d'addition, associatifs à  gauche. Leur manipulations par un parseur descendant, non-déterministe est délicate, et demande l'application de l'algorithme de Greibach. La grammaire résultante aura la forme :
<PRE>
expr ::= terme termlist
termlist ::= EPS | + terme termlist
</PRE>
et le prédicat Prolog, où le contexte gauche du non-terminal <B>termlist</B> a été rendu explicit :
<PRE class="he">
expr(LT,LR,Res) :- terme(LT,LQ,X), 
                   termlist(LQ,LR,X,Res).
terme(['('|LT],LR,X) :- expr(LT,[')'|LR],X).
terme([X|Q],Q,X):-atomeLegal(X).

termlist(['+'|L],LR,Cx,Res) :- terme(L,LQ,Cy),
                               termlist(LQ,LR,add(Cx,Cy),Res).
termlist(LT,LT,Cx,Cx).

</PRE>
Cete fois la traduction en Haskell évite la prolifération de solutions partielles, trop courtes. Les deux clauses de <TT>termlist</TT> sont réciproquement exclusives :
<PRE>
expr_g l = 
 concat [termlist x lq | (x,lq)&lt;-terme l]

termlist cx ('+':l) = 
 concat [termlist (Sum cx x) lq | (x,lq)&lt;-terme l]
termlist cx l = [(cx,l)]
</PRE>
Le résultat du parsing de notre liste-exemple donne <p>
<TT>[("add(add(add(a,b),add(c,d)),e)",";zzzzz")]</TT>.


<TABLE width=100%>
 <TR><TD align=left><A HREF="comres5.html"><IMG SRC="../icons/gb_larr.gif" border=0 align=absmiddle></A></TD>
<TD align=right><A HREF="comres7.html"><IMG SRC="../icons/gb_rarr.gif" border=0 align=absmiddle></A></TD>
</TR>
</TABLE>
<p>


</FONT>
</BODY>

</HTML>
